/********************************************************

	AVI player
	Copyright 2000 Eugene Kuznetsov  (divx@euro.ru)

*********************************************************/


#include <qapp.h>
#include <qtimer.h>
#include <signal.h>
#include <iostream.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#ifdef __FreeBSD__
#include <floatingpoint.h>
#endif
#include "mywidget.h"
#include <default.h>
#include <version.h>
#include <sys/time.h>
MyWidget *m;
extern void killer(int);

PlayerWidget* g_pw=0;

void Usage()
{
    cout<<"Usage: aviplay [-rc] [[-size x y] [<avi-file> [<subtitle-file>]]] "<<endl;
    cout<<"               -size  Start playing movie at dimensions x*y."<<endl;
    cout<<"               -rc    Enables remote control (stdin|stdout)."<<endl;
}
int main(int argc, char **argv)
{
#ifdef __FreeBSD__
    fpsetmask(fpgetmask() & ~(FP_X_DZ|FP_X_INV));
#endif
    
    if(GetAvifileVersion()!=AVIFILE_VERSION)
    {
	cout<<"This binary was compiled for Avifile ver. "<<AVIFILE_VERSION<<", but the library is ver. "<<GetAvifileVersion()<<". Aborting."<<endl;
	return 0;
    }	

    QApplication a(argc,argv);

    int result;
    char* fn;
    m=new MyWidget(384,30);
    g_pw=m;

    int rc=0; // remote control support over stdin/stdout
    int picw=0, pich=0;
        
//    QFont font=MyConfigDialog_impl::ReadFont();
    
    if(argc==2)
	if(strcmp(argv[1], "--help")==0)
	{
	    Usage();
	    return -1;
	}    
    if(argc>=2)
	if(strcmp(argv[1], "-size")==0)
	{
	    if(argc<4)
	    {
		Usage();
	    	return -1;
	    }    
	    picw=atoi(argv[2]);
	    pich=atoi(argv[3]);
	    argv+=3;
	    argc-=3;
	}    
    if(argc>=2)
       if(strcmp (argv[1], "-rc")==0)
       {
           argv++;
           argc--;
           rc=1;
           // non-buffered stdout
           setvbuf (stdout, (char *)NULL, _IOLBF, 0);
       }

    try
    {
	if(argc>=2)
        {
    	    fn=argv[1];
	    const char* subname=NULL;
	    if(argc>2) subname=argv[2];
	    m->initPlayer(fn, subname, picw, pich);
	}
	else m->open_func();
    }
    catch(FatalError& error)
    {
	if(argc>=2)
	    error.Print();
    }	    
//    signal(SIGINT, killer);
    m->show();
    a.setMainWidget(m);
    QTimer t;
    if(rc)
    {
	QObject::connect(&t, SIGNAL(timeout()), m, SLOT(remote_command()));
	t.start(1000);	
    }
    a.exec();
    return 0;
}
