#define QT_THREAD_SUPPORT

#include <iostream>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <qapp.h>
#include <qpainter.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qdragobject.h>
#include <qstrlist.h>

#include "renderer.h"
#include "mywidget.h"
#include "MyConfigImpl.h"

#include <default.h>
#include <except.h>
#include <version.h>
extern MyWidget* m;

DrawEvent g_event;

MyPainter* painter=0;
void MyWidget::readConfig()
{    
    if(painter)
    {
        QFont font=MyConfigDialog_impl::ReadFont();
	painter->setFont(font);
    }
    if(player)
    {
	player->setAsync(MyConfigDialog_impl::ReadAsync());
	player->setSubAsync(MyConfigDialog_impl::ReadSubAsync());
    }	
}

void MyWidget::reseek_func()
{
    double pos=scroller->value();
    pthread_mutex_lock(&g_event.mutex);
    if(g_event.data)pthread_cond_broadcast(&g_event.cond);
    _in_reseek=1;
    pthread_mutex_unlock(&g_event.mutex);
    player->reseek_exact(pos);
    updatePos();
    is_tracking=0;
    _in_reseek=0;
}

void killer(int z)
{
    printf("quit_flag=1\n");
}

void MyWidget::draw_slot()
{
    pthread_mutex_lock(&g_event.mutex);
    if(renderer)
	renderer->Draw(painter, g_event.data);
    pthread_cond_broadcast(&g_event.cond);
    pthread_mutex_unlock(&g_event.mutex);
}
void PixmapButton::paintEvent(QPaintEvent* pe)
{
    QPushButton::paintEvent(pe);
    QPainter p(this);
    p.drawPixmap(2,2,m_pm);
}    

void MyWidget::drawBackground()
{
    if(painter==0)return;
#ifndef USE_SDL
    painter->eraseRect(0,0,width(), height());
//#else
//    painter->eraseRect(0,0,384,50);
#endif    
}
void MyWidget::drawfunc(CImage* im)
{
    static int counter=0;
    static long long lastcount=0;
    if(im)
    {
	long long timestamp=longcount();
	double time=(timestamp-lastcount)/550000000.;
	lastcount=timestamp;
/**
 *
 *  Duration of one frame can vary up to approx. +/- 15 ms. It should not
 * visible by naked eye. The only way to fix it is to remove usleep() with
 * variable duration in main_thread(), but it'll result in 100% CPU usage.
 * That's not what I want.
 *
 */
	pthread_mutex_lock(&m->mutex);
	if(m->renderer)
	{
#ifndef USE_SDL
    	    pthread_mutex_lock(&g_event.mutex);
	    if(m->_in_reseek)
	    {
		pthread_mutex_unlock(&g_event.mutex);
		pthread_mutex_unlock(&m->mutex);
		return;
	    }
	    g_event.data=im;
	    m->draw_func();
	    pthread_cond_wait(&g_event.cond, &g_event.mutex);
	    g_event.data=0;
	    pthread_mutex_unlock(&g_event.mutex);
#else
	    m->renderer->Draw(painter, im);
#endif	    
	}

#ifdef USE_SDL	    
	if(m->renderer && m->player && m->player->HasSubtitles())
		m->renderer->drawSubtitles(m->player->GetCurrentSubtitles());
#else
	if(m->player->HasSubtitles())
	    m->drawSubtitles();
#endif		
	pthread_mutex_unlock(&m->mutex);
    }	
    if((counter++) % 25 == 0)
    {
	m->pos_slot();
	qApp->wakeUpGuiThread();
    }	
}

void MyWidget::moveItems(int w, int h)
{
#ifndef USE_SDL
    if(player && player->isValid() && player->HasSubtitles())
	h-=100;
    else
#endif    
	h-=50;
    scroller->setGeometry(QRect(95, h+5, w-125, 20));
    b_about->move(w-25, h+5);
    b_open->move(5, h+5);
    b_pause->move(25, h+5);
    b_play->move(45, h+5);
    b_stop->move(65, h+5);
    
    l_drop->move(5, h+30);
    l_time->move(w-90, h+30);
}
#define __MODULE__ "AVI player widget"
int MyWidget::initPlayer(const char* filename, const char* subname=NULL, int picw=0, int pich=0)
{
    try
    {
        if(painter==0)
	{
	    painter=new MyPainter(this);
	    QFont font=MyConfigDialog_impl::ReadFont();
	    painter->setFont(font);
//	    painter->setBackgroundColor(QColor(0xdc, 0xdc, 0xdc));
	}    
	if(player->isValid())
	    player->endPlayer();    
	int success=player->initPlayer(filename, GetPhysicalDepth(this), subname);
	readConfig();
        int w=player->width();
	int h=player->height();
	pthread_mutex_lock(&mutex);
#ifdef USE_SDL	
	const long fourcc=fccYUY2;
        try
        {
	    if(!MyConfigDialog_impl::ReadYUV())
		throw FATAL("YUV acceleration disabled");
	    if(player->setColorSpace(fourcc, true))
    		throw FATAL("YUV unsupported by decoder");
	    renderer=CreateYUVRenderer();
    	    if(renderer->Create(this, w, h, fourcc, player->HasSubtitles())!=1)
	        //returns 1 if YUV is unsupported by X
		if(player->setColorSpace(fourcc, false))//shouldn't happen
		    throw FATAL("Error setting YUV decoder output");
	    pthread_mutex_unlock(&mutex);
        }
	catch(FatalError& e)
        {
	    e.PrintAll();
	    delete renderer;
	    renderer=CreateFullscreenRenderer();
	    pthread_mutex_unlock(&mutex);
	    //this call to Create() should happen with unlocked mutex
    	    renderer->Create(this, w, h, 0, player->HasSubtitles());
        }
#else
	renderer=CreateRenderer();
	pthread_mutex_unlock(&mutex);
	renderer->Create(this, w, h, 0, player->HasSubtitles());
#endif
	if(picw && pich)
	    renderer->Resize(picw, pich);

#ifndef USE_SDL
        if(w<150)w=150;
	if(player->HasSubtitles())
	    h+=100;
	else
	    h+=50;
	resize(w,h);
	setMinimumSize(150, 100);
#else
	w=384;
	h=50;
	setFixedSize(w,h);
#endif		    
        move(100,100);	
	setCaption(filename);
        //
	//
        //	Scroll bar
	//
        //
	scroller->setMinValue(0);
	
	double len=player->GetVideoLength();
	if(len==0)
	    len=player->GetAudioLength();
	scroller->setMaxValue(len);
	scroller->setLineStep(len/40);
        scroller->resize(w-90, 20);

	moveItems(w,h);
	
	player->start();
        cout<<"Player started"<<endl;
        return 0;
    }
    catch(FatalError& error)
    {
	endPlayer();
	throw;
    }	
    catch(...)
    {
	cerr<<"Unknown exception"<<endl;
    }	
}

void MyWidget::endPlayer()
{
    if(player)
	player->endPlayer();
    pthread_mutex_lock(&mutex);
    delete renderer;
    renderer=0;
    pthread_mutex_unlock(&mutex);
    delete painter;
    painter=0;
}

void MyWidget::drawSubtitles()
{
	static int nonzero=0;
	const char* cur_sub=player->GetCurrentSubtitles();
	if(cur_sub==0)return;//shouldn't happen


	char* sub=(char*)malloc(strlen(cur_sub)+1);
	strcpy(sub, cur_sub);
	char* sub_start=sub;
	static char* prev_sub=0;
	int w=width();
	int h=height();
	painter->setPen(QPen(QColor(255,255,255)));
	if(prev_sub)
	    if(strcmp(prev_sub, sub))
		painter->fillRect(0, h-100, w, 50, QBrush(QColor(0,0,0)));
	if(prev_sub)free(prev_sub);
	prev_sub=(char*)malloc(strlen(sub)+1);
	strcpy(prev_sub, sub);
	char* run=sub;
	int line=0;
	while(*run!=0)
	{
	    run=strchr(run, '|');
	    if(run)*run=0;
	    painter->drawText(w/2-3*strlen(sub), h-80+20*line, sub);
	    if(run==NULL)break;
	    line++;
	    run++;
	    sub=run;
	}
	painter->setPen(QPen(QColor(0,0,0)));
	free(sub_start);    
}

void MyWidget::updatePosDisplay(int pos) {

	char timing[50];
	double len=player->GetVideoLength();
	if(len==0)
	    len=player->GetAudioLength();
        double stream_time=pos;
        if(stream_time>=3600)
    	    sprintf(timing, "%d:%02d:%02d/",
		int(stream_time/3600), int(stream_time/60)%60,
    		int(stream_time)%60);
	else
	    sprintf(timing, "%02d:%02d/",
		int(stream_time/60)%60,
		int(stream_time)%60);
	if(len>=3600)
	    sprintf(timing+strlen(timing), "%d:%02d:%02d",
		int(len/3600), int(len/60)%60,
		int(len)%60);
	else
	    sprintf(timing+strlen(timing), "%02d:%02d",
		int(len/60)%60,
		int(len)%60);

	l_time->setText(timing);

}

void MyWidget::updatePos()
{
    if(!player->isValid())return;

    painter->setFont(QFont());

    double pos=player->GetPos();
    if(!is_tracking)
	scroller->setValue(pos);
    char dropstring[100];
#ifdef USE_SDL
    int w=384;
    int h=50;
#else    
    int w=width();
    int h=height();
#endif    
    sprintf(dropstring, "Drop: %.2f %%", player->GetDrop());
//    painter->eraseRect(0, h-40, w, 40);
//    painter->drawText(5, h-5, dropstring);
    l_drop->setText(dropstring);
    
    if(w>90 && !(is_tracking == 1))
    {
    	updatePosDisplay(pos);
	}
}    

MyWidget::MyWidget(int width, int height)
{
    renderer=0;
    painter=0;
    player=0;
    is_tracking=0;
    _in_reseek=0;
#ifndef USE_SDL    
    resize(width, height);
#else
    setFixedSize(width, height);
#endif        
    scroller=new QSlider(this, "Slider1");

    QPixmap pm;
    bool result=pm.load(SHARE_PATH"/pause.ppm");
    b_pause=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/open.ppm");
    b_open=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/stop.ppm");
    b_stop=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/play.ppm");
    b_play=new PixmapButton(pm, "", this);
    result=pm.load(SHARE_PATH"/about.ppm");
    b_about=new PixmapButton(pm, "", this);
// Here we can set an icon for the application.
// Does anyone know how to draw an AVI player? :) No? Well, 
// then let's leave this for a while.
    pm.load(SHARE_PATH"/test.png");
    setIcon(pm);
    
    l_drop=new QLabel(this, "");
    l_time=new QLabel(this, "");
        
    scroller->setOrientation(QSlider::Horizontal);
    scroller->setTickmarks(QSlider::Both);
    scroller->setMinValue(0);
    scroller->setMaxValue(120);
    scroller->setLineStep(3);

//    vbar=new QVolumeBar(this, "volume", 0);
//    vbar->move(100, h+30);
//    vbar->resize(40, 15);
    
    b_pause->resize(20, 20);
    b_open->resize(20, 20);
    b_play->resize(20, 20);
    b_stop->resize(20, 20);
    b_about->resize(20, 20);
    
    l_drop->resize(90, 20);
    l_time->resize(85, 20);
    
    moveItems(width,height+20);
    
    connect(scroller, SIGNAL(sliderReleased()), this, SLOT(reseek_func()));
    connect(scroller, SIGNAL(sliderPressed()), this, SLOT(slider_func()));
    connect(scroller, SIGNAL(sliderMoved(int)), this, SLOT(moved_func(int)));
//    connect(scroller, SIGNAL(nextPage()), this, SLOT(nextpage_func()));
//    connect(scroller, SIGNAL(prevPage()), this, SLOT(prevpage_func()));


    connect(b_pause, SIGNAL(clicked()), this, SLOT(pause_func()));
    connect(b_open, SIGNAL(clicked()), this, SLOT(open_func()));    
    connect(b_stop, SIGNAL(clicked()), this, SLOT(stop_func()));    
    connect(b_play, SIGNAL(clicked()), this, SLOT(play_func()));    
    connect(b_about, SIGNAL(clicked()), this, SLOT(about_func()));    
    
    player=CreateAviPlayer();
    player->setKillHandler(&stopfunc);
    player->setDrawCallback2(&drawfunc);
    pthread_mutex_init(&mutex, 0);
    
    const char *path = getenv("WIN32_PATH");
    if(path==0)
	path=WIN32_PATH;
    SetCodecPath(path);
    
    setAcceptDrops(TRUE);
}


void MyWidget::help()
{
    
QMessageBox::information(this,
    "AVI player usage",
    "<h3>Usage:</h3>"
    "aviplay [your-file] [subtitle-file]<br>"
    "<h3>Key bindings:</h3>"
    "X - stop<br>"
    "C - pause<br>"
    "V - play<br>"
    "Q - quit<br>"
#ifdef USE_SDL    
    "Escape toggles fullscreen/windowed mode.<br>"
#endif    
    "Double-click in player window when paused/stopped to bring up configuration menu.<br>"
    "Right-click in movie window when playing to bring up zoom/fullscreen menu.<br>"
    );
}
void MyWidget::about()
{
    char s[512];
    sprintf(s, 
    "AVI player version %.2f<br>"
    "(C) 2000 Eugene Kuznetsov <br>"
    "Based on avifile ( <a href=\"http://divx.euro.ru\">http://divx.euro.ru/</a> ).<br>"
    "Distributed under the GNU Public Licence (GPL) version 2.<br>"
    "Special thanks to: "    
    "<ul>"
    "<li>Authors of Wine project for Win32 DLL loading code."
    "<li>Avery Lee for AVI and ASF parser."
    "<li>Hiroshi Yamashita for porting my sources to FreeBSD."
    "<li>All people from XMPS & avifile mailing lists for their patience and support."
//    "<li>Ms. Hackwrench for the fact that she is."
    "</ul>"
    , AVIFILE_VERSION);
    QMessageBox::information(this, "About", s);
}



void MyWidget::dropEvent(QDropEvent* e)
{
    QStrList i;
    QUriDrag::decode(e, i);
    const char* uri=i.first();
    if(!uri)return;
    if(strlen(uri)<6)return;

    QString file;

    if ( uri && 0==qstrnicmp(uri,"file:/",6) ) 
    {
	uri += 6;
	if ( uri[0] != '/' || uri[1] == '/' ) 
	{
	    // It is local.
	    file = QUriDrag::uriToUnicodeUri(uri);
	    if ( (uri[1] == '/') && (uri[0]=='/') ) 
		file.remove(0,1);
	    else
		file.insert(0,'/');
	    try
	    {
		cerr<<file.ascii()<<endl;
		initPlayer(file.ascii());
	    }
	    catch(...)
	    {
	    }	
	}
    }
}
void MyWidget::dragEnterEvent(QDragEnterEvent* event)
{
   event->accept(QUriDrag::canDecode(event));
}

void MyWidget::moved_func(int value)
{
	updatePosDisplay(value);
}
