#include "qvolumebar.h"
#include <qpainter.h>
QVolumeBar::QVolumeBar(QWidget* parent, const char* name, WFlags f):QWidget(parent, name, f),
	m_value(0), minval(0), maxval(100), tracking(0)
{
}
QVolumeBar::~QVolumeBar(){}
void QVolumeBar::paintEvent( QPaintEvent* e)
{
    if(width()==0)return;
    if(minval==maxval)return;
    QPainter painter(this);
    painter.eraseRect(0, 0, width(), height());
    QPen pen(QColor(0x0, 0x0, 0x0));
    painter.moveTo(width(), 0);
    painter.lineTo(0, height());
    double percent=double(m_value-minval)/(maxval-minval);
    painter.moveTo(width()*percent, height()*(1-percent)+10);
    painter.lineTo(width()*percent, height()*(1-percent)-10);
}
void QVolumeBar::mousePressEvent( QMouseEvent * e)
{
    tracking=1;
}
void QVolumeBar::mouseMoveEvent( QMouseEvent * )
{

}
void QVolumeBar::mouseReleaseEvent( QMouseEvent * e)
{
    if(!tracking)return;
    tracking=0;
    if(width()==0)return;
    if(minval==maxval)return;
    double percent=double(e->x())/width();
    m_value=(int)(minval+(maxval-minval)*percent);
    update();
}	
//#include "qvolumebar.moc"
