/********************************************************

	Video renderer
	Copyright 2000 Eugene Smith (divx@euro.ru)

*********************************************************/
#ifndef _renderer_h
#define _renderer_h
#include <config.h>
#include <qwidget.h>
#include <qpainter.h>
#include <image.h>
extern int width, height;
int GetPhysicalDepth(QPaintDevice* dev);

class VideoRenderer
{
protected:
    QPaintDevice* dev;
    int m_w, m_h;
    int pic_w, pic_h;
public:
    VideoRenderer(){}
    virtual int Create(QWidget* w, int width, int height, int xpos=0, int sub=0) =0;
    virtual int Draw(QPainter* pm, const CImage* data) =0;
    virtual int sync() =0;
    virtual int Resize(int& new_w, int& new_h) =0;
    virtual int toggle_fullscreen(bool maximize=false) =0;
    virtual int drawSubtitles(const char*) =0;
    virtual ~VideoRenderer(){}
};

extern void v555to565(short* dest, const short* src, int w, int h);
extern void zoom_2_to565(short* dest, const short* src, int w, int h);
extern void zoom_2(short* dest, const short* src, int w, int h, int);
extern void zoom(short* dest, const short* src, int dst_w, int dst_h, int src_w, int src_h, int bpp, int xdim=0);


class MyPainter:public QPainter
{
public:
    MyPainter(QPaintDevice* qp):QPainter(qp){}
    virtual GC getGC(){return gc;}
};

VideoRenderer* CreateRenderer();
#ifdef USE_SDL
VideoRenderer* CreateFullscreenRenderer();
VideoRenderer* CreateYUVRenderer();
#endif
#ifdef HAVE_LIBXXF86DGA
VideoRenderer* CreateDGARenderer();
#endif
#endif /* _renderer_h */
