/**************************************************************************

	Example of IAviReadFile & IAviReadStream interface usage.
	Copyright 2000 Eugene Kuznetsov (divx@euro.ru)
	
**************************************************************************/


#include <avifile.h>
#include <stdio.h>
#include <pthread.h>
#include <wine/vfw.h>
#include <aviplay.h>
#include <except.h>
#include <version.h>
#define __MODULE__ "extractor"
int main(int argc, char** argv)
{
    FILE* f=0;
    IAviReadFile* ac=0;
    IAviReadStream* as=0;
    char* zz=0;
    if(GetAvifileVersion()!=AVIFILE_VERSION)
    {
	cout<<"This binary was compiled for Avifile ver. "<<AVIFILE_VERSION<<", but the library is ver. "<<GetAvifileVersion()<<". Aborting."<<endl;
	return 0;
    }	
    try
    {
        Unsigned samp_read, bytes_read;
	f=fopen("./log2.mp3", "wb");
	if(f==0)throw FATAL("Can't open ./log2.mp3 for writing");
	ac=CreateIAviReadFile(argv[1]);
        as=ac->GetStream(0, AviStream::Audio);
        zz=new char[500000];
	as->ReadDirect(zz, 500000, 500000, samp_read, bytes_read);
        fwrite(zz,bytes_read,1,f);
    }
    catch(FatalError& error)
    {
	error.Print();
    }	
    if(f)fclose(f);
    if(ac)delete ac;
    if(zz)delete zz;	
}    