#include <qapp.h>
#include "genctl.h"
#include "recwnd.h"
#include <except.h>
#include <string.h>
#include <unistd.h>

#ifdef __FreeBSD__
#include <floatingpoint.h>
#endif
void my_new_handler()
{
    cerr<<"ERROR: new failed"<<endl;
    exit(1);
}
void Usage()
{
    cerr<<"Usage: qtrecomp [config-file-name]"<<endl
	<<"   Without options: interactive mode"<<endl
	<<"   With one option: batch mode ( processes one file according to config options and exits )"<<endl;
}
class ConsoleCallback: public IRecompressCallback
{
public:
    int state;
    ConsoleCallback():state(0){}
    void setNewState(double progress, double elapsed, double estimated, long long filesize)
    {
    }
    void Finished()
    {
	state=1;
    }
};

int main(int argc, char** argv)
{
#ifdef __FreeBSD__
	fpsetmask(fpgetmask() & ~(FP_X_DZ|FP_X_INV));
#endif
    set_new_handler(&my_new_handler);
    if(argc==1)
    {
        try
	{
	    QApplication app(argc,argv);
    	    QtRecompressorCtl ctl;
	    ctl.show();
	    app.setMainWidget(&ctl);
            app.exec();
	}
        catch(FatalError& e)
	{
	    e.PrintAll();
        }
    }
    else if(argc==2)
    {
	if(strcmp(argv[1], "--help")!=0)
	{
	    ConsoleCallback ck;
	    RecKernel kernel;
	    kernel.loadConfig(argv[1]);
	    kernel.set_callback(&ck);
	    kernel.start_recompress();
	    while(!ck.state)sleep(1);
//	    RecWindow* wnd=new RecWindow(0, &kernel);
//	    wnd->show();
//	    app.setMainWidget(wnd);
//	    wnd->exec();
	}
	else Usage();
    }
    else Usage();
    return 0;
}
