#ifndef CAPWINDOW_H
#define CAPWINDOW_H
#include "v4lxif.h"
#include "capwindow_p.h"
#include <qwidget.h>
#include <qtimer.h>
#include <qpushbutton.h>
#include "renderer.h"
#include "pthread.h"
#include "capproc.h"

#include <strstream>
class CapWindow : public Form1
{ 
    Q_OBJECT

public:
    CapWindow( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~CapWindow();
private:
    QTimer m_timer;
    int known_pos;
    pthread_t thread;
    CaptureProcess* m_cp;
    std::strstream mess;
public slots:
    void Start();
    void Stop();
    void Update();
    void Config();
    void brightChanged(int);
    void contrastChanged(int);
    void colorChanged(int value);
    void hueChanged(int value);
    void PicProperties(bool show);
    void segment();
protected:
    virtual void moveEvent( QMoveEvent * );
    virtual void showEvent( QShowEvent * );
    virtual void hideEvent( QHideEvent * );
    virtual void focusInEvent( QFocusEvent * );
    virtual void focusOutEvent( QFocusEvent * );
    virtual void enterEvent( QEvent * );
    virtual void leaveEvent( QEvent * );
    
    int state;
    v4lxif* v4l;

};

#endif // CAPWINDOW_H
